# Praat script evoContrast/drawGrammar.praat
# Paul Boersma, January 22, 2008

# First select one or more Matrix objects

form Draw grammar
	boolean Draw_articulatory_constraints 1
endform

Erase all
Times
12
Select outer viewport... 0 6 0 3
numberOfGrammars = numberOfSelected ("Matrix")
if numberOfGrammars < 1
	exit First select one or more Matrix objects.
endif
for igram to numberOfGrammars
	grammar'igram' = selected ("Matrix", igram)
endfor
select grammar1
numberOfRows = Get number of rows
number_of_categories = numberOfRows - 1
if draw_articulatory_constraints
	Silver
	Line width... 10
	Draw rows... 0 0 numberOfRows-0.5 numberOfRows+0.5 90 110   ; articulatory constraints
	Line width... 1
	Black
endif
Line width... 2
for igram to numberOfGrammars
	select grammar'igram'
	numberOfRows = Get number of rows
	assert numberOfRows = number_of_categories + 1
	if number_of_categories = 1
		Solid line
		Draw rows... 0 0 0.5 1.5 90 110
	elsif number_of_categories = 2
		Solid line
		Draw rows... 0 0 0.5 1.5 90 110
		Dotted line
		Draw rows... 0 0 1.5 2.5 90 110
	elsif number_of_categories = 3
		Solid line
		Draw rows... 0 0 0.5 1.5 90 110
		Dashed line
		Draw rows... 0 0 1.5 2.5 90 110
		Dotted line
		Draw rows... 0 0 2.5 3.5 90 110
	elsif number_of_categories = 4
		Solid line
		Draw rows... 0 0 0.5 1.5 90 110
		Dashed line
		Draw rows... 0 0 1.5 2.5 90 110
		Dotted line
		Draw rows... 0 0 2.5 3.5 90 110
		Solid line
		Draw rows... 0 0 3.5 4.5 90 110
	endif
endfor
Solid line
Line width... 1
Text bottom... yes Spectral mean (Erb)
Marks bottom every... 1 2 yes yes yes
Text left... yes Ranking value
Marks left every... 1 5 yes yes yes
Draw inner box
Select outer viewport... 0 6 0.3 3
select grammar1
for igram to numberOfGrammars
	plus grammar'igram'
endfor